BOOKS1 - Copying Books


Before the invention of book-printing, it was very hard to make a copy of a book. All the contents had to be re-written by hand by so called scribers. The scriber had been given a book and after several months he finished its copy. One of the most famous scribers lived in the 15th century and his name was Xaverius Endricus Remius Ontius Xendrianus (Xerox). Anyway, the work was very annoying and boring. And the only way to speed it up was to hire more scribers.

Once upon a time, there was a theater ensemble that wanted to play famous Antique Tragedies. The scripts of these plays were divided into many books and actors needed more copies of them, of course. So they hired many scribers to make copies of these books. Imagine you have m books (numbered 1, 2 ... m) that may have different number of pages (p1, p2 ... pm) and you want to make one copy of each of them. Your task is to divide these books among k scribes, k <= m. Each book can be assigned to a single scriber only, and every scriber must get a continuous sequence of books. That means, there exists an increasing succession of numbers 0 = b0 < b1 < b2, ... < bk-1 <= bk = m such that i-th scriber gets a sequence of books with numbers between bi-1+1 and bi. The time needed to make a copy of all the books is determined by the scriber who was assigned the most work. Therefore, our goal is to minimize the maximum number of pages assigned to a single scriber. Your task is to find the optimal assignment.

Input

The input consists of N cases (equal to about 200). The first line of the input contains only positive integer N. Then follow the cases. Each case consists of exactly two lines. At the first line, there are two integers m and k, 1 <= k <= m <= 500. At the second line, there are integers p1, p2, ... pm separated by spaces. All these values are positive and less than 10000000.

Output

For each case, print exactly one line. The line must contain the input succession p1, p2, ... pm divided into exactly k parts such that the maximum sum of a single part should be as small as possible. Use the slash character ('/') to separate the parts. There must be exactly one space character between any two successive numbers and between the number and the slash.

If there is more than one solution, print the one that minimizes the work assigned to the first scriber, then to the second scriber etc. But each scriber must be assigned at least one book.

Example

Sample input:
2
9 3
100 200 300 400 500 600 700 800 900
5 4
100 100 100 100 100

Sample output:
100 200 300 400 500 / 600 700 / 800 900
100 / 100 / 100 / 100 100

hide comments
karan_yadav: 2018-08-10 12:40:47

A better question would be "every scriber need not get a continuous sequence of books" :D

ojvietnam: 2018-06-06 08:28:45

:3

morino_hikari: 2017-08-05 04:57:21

@khanhpqbk, You can try to do a greedy collection of the elements (until the next one cannot be collected because of the maximal value you have obtained or there is less elements than the scribers)from the end of the sequence to the beginning. That will be of help.

gboduljak: 2017-04-25 19:48:31

array partitioning is cool part, nice problem :)

gautam: 2017-02-01 22:03:01

nice problem..

manas0008: 2016-10-18 18:24:34

during binary search add the condition where each element(pi) is greater than mid and also start checking from i=0 not from i=1 by taking the first element during binary search.

mohamednabil97: 2016-09-14 00:38:18

Check your upperbound when doing binary search! caused me a few WA.


Hint(

use sum of the elements of 10e10 as upperbound)

khanhpqbk: 2016-07-20 06:15:45

can anyone explain the true way to print out the output? i find it hard to produce correct output even after getting the right biggest sum (e.g 1700 in case #1 and 200 in case #2)

manas0008: 2016-02-06 19:08:10

Do not go to topcoder binary search tutorial ;D

Deepak Singh Tomar: 2015-07-18 19:29:57

great problem!!!!


Added by:adrian
Date:2004-06-06
Time limit:5s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All
Resource:ACM Central European Programming Contest, Prague 1998